// -- SASS Mixins ----------------------------------------------------

// -------------------------------------------------------------------

// Border-radius

// -------------------------------------------------------------------

@mixin border-radius($radius: $base-border-radius) {
  -webkit-border-radius: $radius;
  border-radius: $radius;
  background-clip: padding-box;  /* stops bg color from leaking outside the border: */
}

// Single side border-radius

@mixin border-top-radius($radius) {
  -webkit-border-top-right-radius: $radius;
  border-top-right-radius: $radius;
   -webkit-border-top-left-radius: $radius;
   border-top-left-radius: $radius;
   background-clip: padding-box;
}
@mixin border-right-radius($radius) {
  -webkit-border-bottom-right-radius: $radius;
  border-bottom-right-radius: $radius;
     -webkit-border-top-right-radius: $radius;
     border-top-right-radius: $radius;
     background-clip: padding-box;
}
@mixin border-bottom-radius($radius) {
  -webkit-border-bottom-right-radius: $radius;
  border-bottom-right-radius: $radius;
   -webkit-border-bottom-left-radius: $radius;
   border-bottom-left-radius: $radius;
   background-clip: padding-box;
}
@mixin border-left-radius($radius) {
  -webkit-border-bottom-left-radius: $radius;
  border-bottom-left-radius: $radius;
     -webkit-border-top-left-radius: $radius;
     border-top-left-radius: $radius;
     background-clip: padding-box;
}

// -------------------------------------------------------------------

// Backface-visibility

// -------------------------------------------------------------------

@mixin backface-visibility($value) {
  -webkit-backface-visibility: $value; /* Safari */
   -khtml-backface-visibility: $value; /* Konqueror HTML */
     -moz-backface-visibility: $value; /* Firefox */
      -ms-backface-visibility: $value;
          backface-visibility: $value;
}


// -------------------------------------------------------------------

// Box-shadow

// -------------------------------------------------------------------

@mixin box-shadow($left, $top, $blur, $color, $inset: false) {
  @if $inset {
    -webkit-box-shadow:inset $left $top $blur $color;
    -moz-box-shadow:inset $left $top $blur $color;
    box-shadow:inset $left $top $blur $color;
  } @else {
    -webkit-box-shadow: $left $top $blur $color;
    -moz-box-shadow: $left $top $blur $color;
    box-shadow: $left $top $blur $color;
  }
}

// -------------------------------------------------------------------

// Box-sizing

// -------------------------------------------------------------------

@mixin box-sizing($box-model) {
  -webkit-box-sizing: $box-model; // Safari <= 5
     -moz-box-sizing: $box-model; // Firefox <= 19
          box-sizing: $box-model;
}

// -------------------------------------------------------------------

// Clearfix

// -------------------------------------------------------------------

@mixin clearfix() {
    &:before,
    &:after {
        content: "";
        display: table;
    }
    &:after {
        clear: both;
    }
}

// -------------------------------------------------------------------

// Font size (REM / PX)

// -------------------------------------------------------------------

@mixin font-size($size-value: $base-font-size, $base-value: $base-font-size) {
    font-size: $size-value + px; // fallback for old browsers
    font-size: ($size-value / $base-value) * 1rem;
}

// -------------------------------------------------------------------

// Grayscale

// -------------------------------------------------------------------

@mixin grayscale_element($value) {
    -webkit-filter: #{"grayscale(#{$value})"};
    -moz-filter: #{"grayscale(#{$value})"};
    filter:#{"grayscale(#{$value})"};
}


// -------------------------------------------------------------------

// Line height (REM / PX)

// -------------------------------------------------------------------

@mixin line-height($height-value: $base-line-height, $base-value: $base-font-size){
    line-height: $height-value + px; //fallback for old browsers
    line-height: ($height-value / $base-value) * 1rem;
}

// -------------------------------------------------------------------

// Opacity

// -------------------------------------------------------------------

@mixin opacity($opacity) {
  opacity: $opacity;
  $opacity-ie: $opacity * 100;
  filter: alpha(opacity=$opacity-ie); //IE8
}

// -------------------------------------------------------------------

// Perspective

// -------------------------------------------------------------------

@mixin perspective($value) {
  -webkit-perspective: $value; /* Safari */
   -khtml-perspective: $value; /* Konqueror HTML */
     -moz-perspective: $value; /* Firefox */
      -ms-perspective: $value;
          perspective: $value;
}

// -------------------------------------------------------------------

// Pseudo

// -------------------------------------------------------------------

@mixin pseudo($display: block, $pos: absolute, $content: '') {
    content: $content;
    display: $display;
    position: $pos;
}

// -------------------------------------------------------------------

// Retina images

// -------------------------------------------------------------------

@mixin image-2x($image, $width, $height) {
  @media (min--moz-device-pixel-ratio: 1.3),
         (-o-min-device-pixel-ratio: 2.6/2),
         (-webkit-min-device-pixel-ratio: 1.3),
         (min-device-pixel-ratio: 1.3),
         (min-resolution: 1.3dppx) {
    /* on retina, use image that's scaled by 2 */
    background-image: url($image);
    background-size: $width $height;
  }
}

// -------------------------------------------------------------------

// Responsive breakpoints

// -------------------------------------------------------------------

@mixin breakpoint($point) {
  @if $point == xlarge {
    @media (min-width: 1200px) { @content; }
  }
  @if $point == large {
    @media (min-width: 1024px) { @content; }
  }
  @else if $point == medium {
    @media (min-width: 900px) { @content; }
  }
  @else if $point == small {
    @media (min-width: 600px)  { @content; }
  }
  @else if $point == xsmall {
    @media (min-width: 480px)  { @content; }
  }
  @else if $point == xxsmall {
    @media (max-width: 479px)  { @content; }
  }
  @else if $point == xxxsmall {
    @media (max-width: 320px)  { @content; }
  }
}

// -------------------------------------------------------------------

// User select

// -------------------------------------------------------------------

@mixin user-select($value) {
  -webkit-touch-callout: $value; /* iOS Safari */
    -webkit-user-select: $value; /* Safari */
     -khtml-user-select: $value; /* Konqueror HTML */
       -moz-user-select: $value; /* Firefox */
        -ms-user-select: $value; /* Internet Explorer/Edge */
            user-select: $value; /* Non-prefixed version, currently
                                  supported by Chrome and Opera */
}

// -------------------------------------------------------------------

// Transformations

// -------------------------------------------------------------------

@mixin transform($transforms) {
     -moz-transform: $transforms;
       -o-transform: $transforms;
      -ms-transform: $transforms;
  -webkit-transform: $transforms;
          transform: $transforms;
}

@mixin transform-style($transform-styles) {
     -moz-transform-style: $transform-styles;
       -o-transform-style: $transform-styles;
      -ms-transform-style: $transform-styles;
  -webkit-transform-style: $transform-styles;
          transform-style: $transform-styles;
}

@mixin animation($animation) {
     -moz-animation: $animation;
       -o-animation: $animation;
      -ms-animation: $animation;
  -webkit-animation: $animation;
          animation: $animation;
}

@mixin scale($scale) {
   @include transform(scale($scale));
}

@mixin rotate($rotate) {
   @include transform(rotate($rotate));
}

@mixin rotateY($rotateY) {
   @include transform(rotateY($rotateY));
}

// translate
@mixin translate ($x, $y) {
   @include transform(translate($x, $y));
}

@mixin translateX ($percentage) {
   @include transform(translateX($percentage));
}

@mixin translateY ($percentage) {
   @include transform(translateY($percentage));
}

// -------------------------------------------------------------------

// Transition

// -------------------------------------------------------------------

@mixin transition($transition...) {
    -moz-transition:    $transition;
    -o-transition:      $transition;
    -webkit-transition: $transition;
    transition:         $transition;
}

// -------------------------------------------------------------------

// User select

// -------------------------------------------------------------------

@mixin user-select($user-select) {
  -webkit-user-select: $user-select;
  -moz-user-select: $user-select;
  -ms-user-select: $user-select;
  user-select: $user-select;
}
